package sw1.archivioStudentiEsteso;

import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Collections;

public class Archivio
{
	LinkedList lista = new LinkedList();
	static ComparaPerNome cpn = null;
	static ComparaPerCognome cpc = null;
	static ComparaPerMedia cpme = null;
	static ComparaPerMatricola cpma = null;
	boolean ordinatoPerNome = false, ordinatoPerCognome = false, ordinatoPerMatricola = false, ordinatoPerMedia = false;

	public void insert(Studente s)
	{
		lista.add(s);
	}

	public void stampaPerNome()
	{
		if(!ordinatoPerNome)
		{
			Collections.sort(lista, cpn);
			ordinatoPerNome = true;
			ordinatoPerCognome = ordinatoPerMatricola = ordinatoPerMedia = false;
		}
		stampa();
	}

	public void stampaPerCognome()
	{
		if(!ordinatoPerCognome)
		{
			Collections.sort(lista, cpc);
			ordinatoPerCognome = true;
			ordinatoPerNome = ordinatoPerMatricola = ordinatoPerMedia = false;
		}
		stampa();
	}

	public void stampaPerMedia()
	{
		if(!ordinatoPerMedia)
		{
			Collections.sort(lista, cpme);
			ordinatoPerMedia = true;
			ordinatoPerNome = ordinatoPerMatricola = ordinatoPerCognome = false;
		}
		stampa();
	}

	public void stampaPerMatricola()
	{
		if(!ordinatoPerMatricola)
		{
			Collections.sort(lista, cpma);
			ordinatoPerMatricola = true;
			ordinatoPerNome = ordinatoPerMedia = ordinatoPerCognome = false;
		}
		stampa();
	}

	public void stampa()
	{
		ListIterator iter = lista.listIterator(0);
		while(iter.hasNext())
		{
			System.out.println(iter.next().toString());
		}
	}

	static
	{
		cpn = new ComparaPerNome();
		cpc = new ComparaPerCognome();
		cpma = new ComparaPerMatricola();
		cpme = new ComparaPerMedia();
	}
}
